'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _watch2 = require('watch');

var _watch3 = _interopRequireDefault(_watch2);

var _safe = require('colors/safe');

var _safe2 = _interopRequireDefault(_safe);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SwiftyWatcher = function () {
  function SwiftyWatcher(resolver) {
    _classCallCheck(this, SwiftyWatcher);

    this.resolver = resolver;
  }

  /**
   * watch files under a directory
   * @param {String} directory in which all containing files will be watched. directory path is based on the location in the file system that the node process originated from.
   */


  _createClass(SwiftyWatcher, [{
    key: 'watch',
    value: function watch(directory) {
      var _this = this;

      console.log('Start watching files in "' + process.cwd() + '/' + directory + '" for updates...');

      // start watching files and compile them as you go.
      _watch3.default.createMonitor(process.cwd() + '/' + directory, { interval: 0.1 }, function (monitor) {
        monitor.on("created", function (f, stat) {
          // Handle new files
          var regex = new RegExp("^" + (process.cwd() + '/' + directory));
          console.log(_safe2.default.green('[+] created new file: ') + f.replace(regex, ''));
          _this.resolver.addLayerByFileName(f).then(function (layerContainer) {
            console.log('Layer registered: ' + layerContainer.layerKey.type + ':' + layerContainer.layerKey.name + '\n');
          });
        });
        monitor.on("changed", function (f, curr, prev) {
          // Handle file changes
          var regex = new RegExp("^" + (process.cwd() + '/' + directory));
          console.log(_safe2.default.blue('[~] changed file: ') + f.replace(regex, ''));
          _this.resolver.addLayerByFileName(f).then(function (layerContainer) {
            console.log('Layer re-registered: ' + layerContainer.layerKey.type + ':' + layerContainer.layerKey.name + '\n');
          });
        });
        monitor.on("removed", function (f, stat) {
          // Handle removed files
          var regex = new RegExp("^" + (process.cwd() + '/' + directory));
          console.log(_safe2.default.red('[-] removed file: ') + f.replace(regex, ''));
          _this.resolver.removeLayerByFileName(f).then(function (layerContainer) {
            console.log('Layer de-registered: ' + layerContainer.layerKey.type + ':' + layerContainer.layerKey.name + '\n');
          });
        });
      });
    }
  }]);

  return SwiftyWatcher;
}();

exports.default = SwiftyWatcher;